/**
 */
package bcn.lang;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see bcn.lang.LangFactory
 * @model kind="package"
 * @generated
 */
public interface LangPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "lang";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.Lang.bcn";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "lang";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  LangPackage eINSTANCE = bcn.lang.impl.LangPackageImpl.init();

  /**
   * The meta object id for the '{@link bcn.lang.impl.ControllerImpl <em>Controller</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.ControllerImpl
   * @see bcn.lang.impl.LangPackageImpl#getController()
   * @generated
   */
  int CONTROLLER = 0;

  /**
   * The feature id for the '<em><b>Pckg</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTROLLER__PCKG = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTROLLER__NAME = 1;

  /**
   * The feature id for the '<em><b>Decls</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTROLLER__DECLS = 2;

  /**
   * The number of structural features of the '<em>Controller</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONTROLLER_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link bcn.lang.impl.DeclarationImpl <em>Declaration</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.DeclarationImpl
   * @see bcn.lang.impl.LangPackageImpl#getDeclaration()
   * @generated
   */
  int DECLARATION = 1;

  /**
   * The number of structural features of the '<em>Declaration</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int DECLARATION_FEATURE_COUNT = 0;

  /**
   * The meta object id for the '{@link bcn.lang.impl.BehaviorDefImpl <em>Behavior Def</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.BehaviorDefImpl
   * @see bcn.lang.impl.LangPackageImpl#getBehaviorDef()
   * @generated
   */
  int BEHAVIOR_DEF = 2;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF__NAME = DECLARATION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Types</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF__TYPES = DECLARATION_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Params</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF__PARAMS = DECLARATION_FEATURE_COUNT + 2;

  /**
   * The feature id for the '<em><b>Inputs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF__INPUTS = DECLARATION_FEATURE_COUNT + 3;

  /**
   * The feature id for the '<em><b>Outputs</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF__OUTPUTS = DECLARATION_FEATURE_COUNT + 4;

  /**
   * The number of structural features of the '<em>Behavior Def</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int BEHAVIOR_DEF_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 5;

  /**
   * The meta object id for the '{@link bcn.lang.impl.JavaParamImpl <em>Java Param</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.JavaParamImpl
   * @see bcn.lang.impl.LangPackageImpl#getJavaParam()
   * @generated
   */
  int JAVA_PARAM = 3;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JAVA_PARAM__TYPE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JAVA_PARAM__NAME = 1;

  /**
   * The number of structural features of the '<em>Java Param</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int JAVA_PARAM_FEATURE_COUNT = 2;

  /**
   * The meta object id for the '{@link bcn.lang.impl.InputPortDefImpl <em>Input Port Def</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.InputPortDefImpl
   * @see bcn.lang.impl.LangPackageImpl#getInputPortDef()
   * @generated
   */
  int INPUT_PORT_DEF = 4;

  /**
   * The feature id for the '<em><b>Influence</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INPUT_PORT_DEF__INFLUENCE = 0;

  /**
   * The feature id for the '<em><b>Port</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INPUT_PORT_DEF__PORT = 1;

  /**
   * The feature id for the '<em><b>Buffer</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INPUT_PORT_DEF__BUFFER = 2;

  /**
   * The number of structural features of the '<em>Input Port Def</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INPUT_PORT_DEF_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link bcn.lang.impl.InfluenceDefImpl <em>Influence Def</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.InfluenceDefImpl
   * @see bcn.lang.impl.LangPackageImpl#getInfluenceDef()
   * @generated
   */
  int INFLUENCE_DEF = 5;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF__NAME = 0;

  /**
   * The feature id for the '<em><b>Array</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF__ARRAY = 1;

  /**
   * The feature id for the '<em><b>Min</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF__MIN = 2;

  /**
   * The feature id for the '<em><b>Max</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF__MAX = 3;

  /**
   * The feature id for the '<em><b>Dec</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF__DEC = 4;

  /**
   * The number of structural features of the '<em>Influence Def</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INFLUENCE_DEF_FEATURE_COUNT = 5;

  /**
   * The meta object id for the '{@link bcn.lang.impl.PortDefImpl <em>Port Def</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.PortDefImpl
   * @see bcn.lang.impl.LangPackageImpl#getPortDef()
   * @generated
   */
  int PORT_DEF = 6;

  /**
   * The feature id for the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_DEF__TYPE = 0;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_DEF__NAME = 1;

  /**
   * The feature id for the '<em><b>Array</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_DEF__ARRAY = 2;

  /**
   * The number of structural features of the '<em>Port Def</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_DEF_FEATURE_COUNT = 3;

  /**
   * The meta object id for the '{@link bcn.lang.impl.InstanceImpl <em>Instance</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.InstanceImpl
   * @see bcn.lang.impl.LangPackageImpl#getInstance()
   * @generated
   */
  int INSTANCE = 7;

  /**
   * The feature id for the '<em><b>Behavior</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANCE__BEHAVIOR = DECLARATION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Types</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANCE__TYPES = DECLARATION_FEATURE_COUNT + 1;

  /**
   * The feature id for the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANCE__NAME = DECLARATION_FEATURE_COUNT + 2;

  /**
   * The number of structural features of the '<em>Instance</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int INSTANCE_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 3;

  /**
   * The meta object id for the '{@link bcn.lang.impl.ConnectionImpl <em>Connection</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.ConnectionImpl
   * @see bcn.lang.impl.LangPackageImpl#getConnection()
   * @generated
   */
  int CONNECTION = 8;

  /**
   * The feature id for the '<em><b>Src</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTION__SRC = DECLARATION_FEATURE_COUNT + 0;

  /**
   * The feature id for the '<em><b>Dests</b></em>' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTION__DESTS = DECLARATION_FEATURE_COUNT + 1;

  /**
   * The number of structural features of the '<em>Connection</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int CONNECTION_FEATURE_COUNT = DECLARATION_FEATURE_COUNT + 2;

  /**
   * The meta object id for the '{@link bcn.lang.impl.PortRefImpl <em>Port Ref</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see bcn.lang.impl.PortRefImpl
   * @see bcn.lang.impl.LangPackageImpl#getPortRef()
   * @generated
   */
  int PORT_REF = 9;

  /**
   * The feature id for the '<em><b>Behavior</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_REF__BEHAVIOR = 0;

  /**
   * The feature id for the '<em><b>Port</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_REF__PORT = 1;

  /**
   * The feature id for the '<em><b>Index</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_REF__INDEX = 2;

  /**
   * The number of structural features of the '<em>Port Ref</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PORT_REF_FEATURE_COUNT = 3;


  /**
   * Returns the meta object for class '{@link bcn.lang.Controller <em>Controller</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Controller</em>'.
   * @see bcn.lang.Controller
   * @generated
   */
  EClass getController();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.Controller#getPckg <em>Pckg</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Pckg</em>'.
   * @see bcn.lang.Controller#getPckg()
   * @see #getController()
   * @generated
   */
  EAttribute getController_Pckg();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.Controller#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.Controller#getName()
   * @see #getController()
   * @generated
   */
  EAttribute getController_Name();

  /**
   * Returns the meta object for the containment reference list '{@link bcn.lang.Controller#getDecls <em>Decls</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Decls</em>'.
   * @see bcn.lang.Controller#getDecls()
   * @see #getController()
   * @generated
   */
  EReference getController_Decls();

  /**
   * Returns the meta object for class '{@link bcn.lang.Declaration <em>Declaration</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Declaration</em>'.
   * @see bcn.lang.Declaration
   * @generated
   */
  EClass getDeclaration();

  /**
   * Returns the meta object for class '{@link bcn.lang.BehaviorDef <em>Behavior Def</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Behavior Def</em>'.
   * @see bcn.lang.BehaviorDef
   * @generated
   */
  EClass getBehaviorDef();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.BehaviorDef#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.BehaviorDef#getName()
   * @see #getBehaviorDef()
   * @generated
   */
  EAttribute getBehaviorDef_Name();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.BehaviorDef#getTypes <em>Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Types</em>'.
   * @see bcn.lang.BehaviorDef#getTypes()
   * @see #getBehaviorDef()
   * @generated
   */
  EAttribute getBehaviorDef_Types();

  /**
   * Returns the meta object for the containment reference list '{@link bcn.lang.BehaviorDef#getParams <em>Params</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Params</em>'.
   * @see bcn.lang.BehaviorDef#getParams()
   * @see #getBehaviorDef()
   * @generated
   */
  EReference getBehaviorDef_Params();

  /**
   * Returns the meta object for the containment reference list '{@link bcn.lang.BehaviorDef#getInputs <em>Inputs</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Inputs</em>'.
   * @see bcn.lang.BehaviorDef#getInputs()
   * @see #getBehaviorDef()
   * @generated
   */
  EReference getBehaviorDef_Inputs();

  /**
   * Returns the meta object for the containment reference list '{@link bcn.lang.BehaviorDef#getOutputs <em>Outputs</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Outputs</em>'.
   * @see bcn.lang.BehaviorDef#getOutputs()
   * @see #getBehaviorDef()
   * @generated
   */
  EReference getBehaviorDef_Outputs();

  /**
   * Returns the meta object for class '{@link bcn.lang.JavaParam <em>Java Param</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Java Param</em>'.
   * @see bcn.lang.JavaParam
   * @generated
   */
  EClass getJavaParam();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.JavaParam#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see bcn.lang.JavaParam#getType()
   * @see #getJavaParam()
   * @generated
   */
  EAttribute getJavaParam_Type();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.JavaParam#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.JavaParam#getName()
   * @see #getJavaParam()
   * @generated
   */
  EAttribute getJavaParam_Name();

  /**
   * Returns the meta object for class '{@link bcn.lang.InputPortDef <em>Input Port Def</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Input Port Def</em>'.
   * @see bcn.lang.InputPortDef
   * @generated
   */
  EClass getInputPortDef();

  /**
   * Returns the meta object for the containment reference '{@link bcn.lang.InputPortDef#getInfluence <em>Influence</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Influence</em>'.
   * @see bcn.lang.InputPortDef#getInfluence()
   * @see #getInputPortDef()
   * @generated
   */
  EReference getInputPortDef_Influence();

  /**
   * Returns the meta object for the containment reference '{@link bcn.lang.InputPortDef#getPort <em>Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Port</em>'.
   * @see bcn.lang.InputPortDef#getPort()
   * @see #getInputPortDef()
   * @generated
   */
  EReference getInputPortDef_Port();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InputPortDef#getBuffer <em>Buffer</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Buffer</em>'.
   * @see bcn.lang.InputPortDef#getBuffer()
   * @see #getInputPortDef()
   * @generated
   */
  EAttribute getInputPortDef_Buffer();

  /**
   * Returns the meta object for class '{@link bcn.lang.InfluenceDef <em>Influence Def</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Influence Def</em>'.
   * @see bcn.lang.InfluenceDef
   * @generated
   */
  EClass getInfluenceDef();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InfluenceDef#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.InfluenceDef#getName()
   * @see #getInfluenceDef()
   * @generated
   */
  EAttribute getInfluenceDef_Name();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InfluenceDef#getArray <em>Array</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Array</em>'.
   * @see bcn.lang.InfluenceDef#getArray()
   * @see #getInfluenceDef()
   * @generated
   */
  EAttribute getInfluenceDef_Array();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InfluenceDef#getMin <em>Min</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Min</em>'.
   * @see bcn.lang.InfluenceDef#getMin()
   * @see #getInfluenceDef()
   * @generated
   */
  EAttribute getInfluenceDef_Min();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InfluenceDef#getMax <em>Max</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Max</em>'.
   * @see bcn.lang.InfluenceDef#getMax()
   * @see #getInfluenceDef()
   * @generated
   */
  EAttribute getInfluenceDef_Max();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.InfluenceDef#getDec <em>Dec</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Dec</em>'.
   * @see bcn.lang.InfluenceDef#getDec()
   * @see #getInfluenceDef()
   * @generated
   */
  EAttribute getInfluenceDef_Dec();

  /**
   * Returns the meta object for class '{@link bcn.lang.PortDef <em>Port Def</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Def</em>'.
   * @see bcn.lang.PortDef
   * @generated
   */
  EClass getPortDef();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.PortDef#getType <em>Type</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Type</em>'.
   * @see bcn.lang.PortDef#getType()
   * @see #getPortDef()
   * @generated
   */
  EAttribute getPortDef_Type();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.PortDef#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.PortDef#getName()
   * @see #getPortDef()
   * @generated
   */
  EAttribute getPortDef_Name();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.PortDef#getArray <em>Array</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Array</em>'.
   * @see bcn.lang.PortDef#getArray()
   * @see #getPortDef()
   * @generated
   */
  EAttribute getPortDef_Array();

  /**
   * Returns the meta object for class '{@link bcn.lang.Instance <em>Instance</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Instance</em>'.
   * @see bcn.lang.Instance
   * @generated
   */
  EClass getInstance();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.Instance#getBehavior <em>Behavior</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Behavior</em>'.
   * @see bcn.lang.Instance#getBehavior()
   * @see #getInstance()
   * @generated
   */
  EAttribute getInstance_Behavior();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.Instance#getTypes <em>Types</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Types</em>'.
   * @see bcn.lang.Instance#getTypes()
   * @see #getInstance()
   * @generated
   */
  EAttribute getInstance_Types();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.Instance#getName <em>Name</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Name</em>'.
   * @see bcn.lang.Instance#getName()
   * @see #getInstance()
   * @generated
   */
  EAttribute getInstance_Name();

  /**
   * Returns the meta object for class '{@link bcn.lang.Connection <em>Connection</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Connection</em>'.
   * @see bcn.lang.Connection
   * @generated
   */
  EClass getConnection();

  /**
   * Returns the meta object for the containment reference '{@link bcn.lang.Connection#getSrc <em>Src</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference '<em>Src</em>'.
   * @see bcn.lang.Connection#getSrc()
   * @see #getConnection()
   * @generated
   */
  EReference getConnection_Src();

  /**
   * Returns the meta object for the containment reference list '{@link bcn.lang.Connection#getDests <em>Dests</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the containment reference list '<em>Dests</em>'.
   * @see bcn.lang.Connection#getDests()
   * @see #getConnection()
   * @generated
   */
  EReference getConnection_Dests();

  /**
   * Returns the meta object for class '{@link bcn.lang.PortRef <em>Port Ref</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Port Ref</em>'.
   * @see bcn.lang.PortRef
   * @generated
   */
  EClass getPortRef();

  /**
   * Returns the meta object for the reference '{@link bcn.lang.PortRef#getBehavior <em>Behavior</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Behavior</em>'.
   * @see bcn.lang.PortRef#getBehavior()
   * @see #getPortRef()
   * @generated
   */
  EReference getPortRef_Behavior();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.PortRef#getPort <em>Port</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Port</em>'.
   * @see bcn.lang.PortRef#getPort()
   * @see #getPortRef()
   * @generated
   */
  EAttribute getPortRef_Port();

  /**
   * Returns the meta object for the attribute '{@link bcn.lang.PortRef#getIndex <em>Index</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Index</em>'.
   * @see bcn.lang.PortRef#getIndex()
   * @see #getPortRef()
   * @generated
   */
  EAttribute getPortRef_Index();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  LangFactory getLangFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link bcn.lang.impl.ControllerImpl <em>Controller</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.ControllerImpl
     * @see bcn.lang.impl.LangPackageImpl#getController()
     * @generated
     */
    EClass CONTROLLER = eINSTANCE.getController();

    /**
     * The meta object literal for the '<em><b>Pckg</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONTROLLER__PCKG = eINSTANCE.getController_Pckg();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute CONTROLLER__NAME = eINSTANCE.getController_Name();

    /**
     * The meta object literal for the '<em><b>Decls</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONTROLLER__DECLS = eINSTANCE.getController_Decls();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.DeclarationImpl <em>Declaration</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.DeclarationImpl
     * @see bcn.lang.impl.LangPackageImpl#getDeclaration()
     * @generated
     */
    EClass DECLARATION = eINSTANCE.getDeclaration();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.BehaviorDefImpl <em>Behavior Def</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.BehaviorDefImpl
     * @see bcn.lang.impl.LangPackageImpl#getBehaviorDef()
     * @generated
     */
    EClass BEHAVIOR_DEF = eINSTANCE.getBehaviorDef();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BEHAVIOR_DEF__NAME = eINSTANCE.getBehaviorDef_Name();

    /**
     * The meta object literal for the '<em><b>Types</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute BEHAVIOR_DEF__TYPES = eINSTANCE.getBehaviorDef_Types();

    /**
     * The meta object literal for the '<em><b>Params</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference BEHAVIOR_DEF__PARAMS = eINSTANCE.getBehaviorDef_Params();

    /**
     * The meta object literal for the '<em><b>Inputs</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference BEHAVIOR_DEF__INPUTS = eINSTANCE.getBehaviorDef_Inputs();

    /**
     * The meta object literal for the '<em><b>Outputs</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference BEHAVIOR_DEF__OUTPUTS = eINSTANCE.getBehaviorDef_Outputs();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.JavaParamImpl <em>Java Param</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.JavaParamImpl
     * @see bcn.lang.impl.LangPackageImpl#getJavaParam()
     * @generated
     */
    EClass JAVA_PARAM = eINSTANCE.getJavaParam();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JAVA_PARAM__TYPE = eINSTANCE.getJavaParam_Type();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute JAVA_PARAM__NAME = eINSTANCE.getJavaParam_Name();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.InputPortDefImpl <em>Input Port Def</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.InputPortDefImpl
     * @see bcn.lang.impl.LangPackageImpl#getInputPortDef()
     * @generated
     */
    EClass INPUT_PORT_DEF = eINSTANCE.getInputPortDef();

    /**
     * The meta object literal for the '<em><b>Influence</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INPUT_PORT_DEF__INFLUENCE = eINSTANCE.getInputPortDef_Influence();

    /**
     * The meta object literal for the '<em><b>Port</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference INPUT_PORT_DEF__PORT = eINSTANCE.getInputPortDef_Port();

    /**
     * The meta object literal for the '<em><b>Buffer</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INPUT_PORT_DEF__BUFFER = eINSTANCE.getInputPortDef_Buffer();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.InfluenceDefImpl <em>Influence Def</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.InfluenceDefImpl
     * @see bcn.lang.impl.LangPackageImpl#getInfluenceDef()
     * @generated
     */
    EClass INFLUENCE_DEF = eINSTANCE.getInfluenceDef();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INFLUENCE_DEF__NAME = eINSTANCE.getInfluenceDef_Name();

    /**
     * The meta object literal for the '<em><b>Array</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INFLUENCE_DEF__ARRAY = eINSTANCE.getInfluenceDef_Array();

    /**
     * The meta object literal for the '<em><b>Min</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INFLUENCE_DEF__MIN = eINSTANCE.getInfluenceDef_Min();

    /**
     * The meta object literal for the '<em><b>Max</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INFLUENCE_DEF__MAX = eINSTANCE.getInfluenceDef_Max();

    /**
     * The meta object literal for the '<em><b>Dec</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INFLUENCE_DEF__DEC = eINSTANCE.getInfluenceDef_Dec();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.PortDefImpl <em>Port Def</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.PortDefImpl
     * @see bcn.lang.impl.LangPackageImpl#getPortDef()
     * @generated
     */
    EClass PORT_DEF = eINSTANCE.getPortDef();

    /**
     * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_DEF__TYPE = eINSTANCE.getPortDef_Type();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_DEF__NAME = eINSTANCE.getPortDef_Name();

    /**
     * The meta object literal for the '<em><b>Array</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_DEF__ARRAY = eINSTANCE.getPortDef_Array();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.InstanceImpl <em>Instance</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.InstanceImpl
     * @see bcn.lang.impl.LangPackageImpl#getInstance()
     * @generated
     */
    EClass INSTANCE = eINSTANCE.getInstance();

    /**
     * The meta object literal for the '<em><b>Behavior</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INSTANCE__BEHAVIOR = eINSTANCE.getInstance_Behavior();

    /**
     * The meta object literal for the '<em><b>Types</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INSTANCE__TYPES = eINSTANCE.getInstance_Types();

    /**
     * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute INSTANCE__NAME = eINSTANCE.getInstance_Name();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.ConnectionImpl <em>Connection</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.ConnectionImpl
     * @see bcn.lang.impl.LangPackageImpl#getConnection()
     * @generated
     */
    EClass CONNECTION = eINSTANCE.getConnection();

    /**
     * The meta object literal for the '<em><b>Src</b></em>' containment reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONNECTION__SRC = eINSTANCE.getConnection_Src();

    /**
     * The meta object literal for the '<em><b>Dests</b></em>' containment reference list feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference CONNECTION__DESTS = eINSTANCE.getConnection_Dests();

    /**
     * The meta object literal for the '{@link bcn.lang.impl.PortRefImpl <em>Port Ref</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see bcn.lang.impl.PortRefImpl
     * @see bcn.lang.impl.LangPackageImpl#getPortRef()
     * @generated
     */
    EClass PORT_REF = eINSTANCE.getPortRef();

    /**
     * The meta object literal for the '<em><b>Behavior</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference PORT_REF__BEHAVIOR = eINSTANCE.getPortRef_Behavior();

    /**
     * The meta object literal for the '<em><b>Port</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_REF__PORT = eINSTANCE.getPortRef_Port();

    /**
     * The meta object literal for the '<em><b>Index</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute PORT_REF__INDEX = eINSTANCE.getPortRef_Index();

  }

} //LangPackage
