package bcn;


public class InputRegister<T> implements InputPort<T> {
    
    /** Received message. */
    private T msg;
    
    
    public InputRegister() {
        msg = null;
    }
    
    
    @Override
    public synchronized T get() {
        T msg = this.msg;
        this.msg = null;
        return msg;
    }
    
    
    @Override
    public synchronized T peek() {
        return msg;  // is 'synchronized' really needed for a single memory access instruction?
    }
    
    
    @Override
    public synchronized void put(T msg) {
        if (msg == null) {
            throw new IllegalArgumentException("Invalid null message.");
        }
        this.msg = msg;
    }
    
}
