package foraging;

import com.cyberbotics.webots.controller.DifferentialWheels;


public class Drive extends foraging_stub.Drive_stub {
    
    static public class Speed {
        public final float left, right;
        
        public Speed(float left, float right) {
            this.left = Misc.clipRange(left, -1, 1);
            this.right = Misc.clipRange(right, -1, 1);
        }
    }
    
    
    private final DifferentialWheels robot;
    private final float maxSpeed;
    
    
    public Drive(DifferentialWheels robot) {
        super();
        this.robot = robot;
        maxSpeed = (float)robot.getMaxSpeed();
    }
    
    
    @Override
    public void step() {
        Speed s = _speed.get();
        if (s != null) {
            //System.out.println("Drive: setSpeed(" + s.left + ',' + s.right + ')');
            robot.setSpeed(s.left*maxSpeed, s.right*maxSpeed);
        }
    }
    
}
