package foraging;

import java.util.Random;


public class Misc {
    
    static public final int CONTROL_STEP = 32;
    
    
    static public final Location CHARGER = new Location(0.4f, 0.3f),
                                 GOAL = new Location(0.4f, 0.0f);
    
    
    static public final float GOAL_R = 0.18f;
    
    
    static public final Random RANDOM = new Random(4);
    
    
    static public int steps(int ms) {
        return ms/CONTROL_STEP;
    }
    
    
    static public float stdRange(float value, float min, float max) {
        return (clipRange(value, min, max)-min)/(max-min);
    }
    
    
    static public float clipRange(float value, float min, float max) {
        return (value < min  ?  min  :  (value > max  ?  max  :  value));
    }
    
    
    static public float stdAngle(float angle) {
        return (angle > (float)Math.PI  ?  angle - 2*(float)Math.PI  :  (angle <= -(float)Math.PI  ?  angle + 2*(float)Math.PI  :  angle));
    }
    
    
    static public int rndRange(int min, int max) {
        return min + RANDOM.nextInt(max-min);
    }
    
    
    static public boolean happens(float probability) {
        return RANDOM.nextFloat() < probability;
    }
    
    
    static public float dist(float x1, float z1, float x2, float z2) {
    	return (float)Math.sqrt(dist2(x1, z1, x2, z2));
    }
    
    
    static public float dist2(float x1, float z1, float x2, float z2) {
    	float dx = x1-x2;
    	float dz = z1-z2;
    	return dx*dx + dz*dz;
    }
    
}
